﻿using System;
using System.Collections.Generic;
using System.Linq;
using AcmeTicketAgencyWebRole.Repositories;

namespace AcmeTicketAgencyWebRole.Models
{
    public class EventRepository
    {
        public static IList<Event> Events = new List<Event>();
        private static int nextEventId = 1;

        static EventRepository()
        {
            Event e = new Event();
            e.Artist = "Lady Gaga";
            e.Date = new DateTime(2011, 3, 10);
            e.EventId = nextEventId++;
            e.EventName = "Universal Tour";
            e.Genre = "Pop";
            e.Location = "New York, New York";
            e.TicketInventory = 1000;
            e.TicketPrice = 5;
            Events.Add(e);

            Event f = new Event();
            f.Artist = "Boston Symphony";
            f.Date = new DateTime(2011, 6, 8);
            f.EventId = nextEventId++;
            f.EventName = "Beethoven Night Concert";
            f.Genre = "Classical";
            f.Location = "Boston, Massachusetts";
            f.TicketInventory = 300;
            f.TicketPrice = 25;
            Events.Add(f);

        }

        public IList<Event> QueryEvents()
        {
            IList<Event> list = new List<Event>();                
            foreach (Event evt in Events)
                list.Add(evt);

            return list;
        }

        public static Event GetEvent(int eventId)
        {
            IEnumerable<Event> query = from e in Events
                                      where e.EventId == eventId
                                      select e;
            Event evt = query.First<Event>();
            return evt;
        }

        public static Event GetEvent(string eventName)
        {
            IEnumerable<Event> query = from e in Events
                                     where e.EventName == eventName
                                     select e;
            Event evt = query.First<Event>();
            return evt;
        }

        public void AddEvent(string eventName, string artist, DateTime date, string genre, string location, int ticketInventory, int ticketPrice)
        {
            Event evt = new Event();
            evt.EventName = eventName;
            evt.Artist = artist;
            evt.Date = date;
            evt.Genre = genre;
            evt.Location = location;
            evt.TicketInventory = ticketInventory;
            evt.TicketPrice = ticketPrice;
            evt.EventId = nextEventId++;

            Events.Add(evt);
        }



    }

}