﻿using System;
using System.Collections.Generic;
using System.Linq;
using AcmeTicketAgencyWebRole.Repositories;

namespace AcmeTicketAgencyWebRole.Models
{
    public class OrdersRepository
    {
        public static IList<InternalOrder> Orders = new List<InternalOrder>();
        private static int nextOrderId = 1;

        static OrdersRepository()
        {
            InternalOrder o = new InternalOrder();
            o.EventId = 1;
            o.NumberTickets = 2;
            o.UserId = 1;
            o.OrderId = nextOrderId++;
            Orders.Add(o);
        }

        public IList<Order> QueryOrders()
        {
            IList<User> users = UserRepository.Users;
            IList<Event> events = EventRepository.Events;
            IList<InternalOrder> orders = OrdersRepository.Orders;

            IList<Order> list = new List<Order>();
            foreach (InternalOrder order in orders)
            {
                Order o = new Order();
                o.NumberTickets = order.NumberTickets;
                o.User = UserRepository.GetUser(order.UserId);
                o.Event = EventRepository.GetEvent(order.EventId);
                o.EventId = order.EventId;
                list.Add(o);
            }

            return list;
        }

        public void AddOrder(string userName, int eventId, int numberTickets)
        {
            User user = UserRepository.GetUser(userName);
            Event evt = EventRepository.GetEvent(eventId);

            evt.TicketInventory = evt.TicketInventory - numberTickets;
            
            InternalOrder order = new InternalOrder();
            order.UserId = user.Id;
            order.NumberTickets = numberTickets;
            order.EventId = evt.EventId;
            order.OrderId = nextOrderId++;
            Orders.Add(order);
        }

    }
}