﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Data.Objects;
using AcmeTicketAgencyWebRole.Repositories;

namespace AcmeTicketAgencyWebRole.Models
{
    public class UserRepository
    {
        public static IList<User> Users = new List<User>();
        private int nextUserId = 1;

        public UserRepository()
        {
            User a = new User();
            a.UserName = "Jim Jones";
            a.Id = nextUserId++;
            Users.Add(a);

            User b = new User();
            b.UserName = "Mary Roe";
            b.Id = nextUserId++;
            Users.Add(b);
        }

        public IList<User> QueryUsers()
        {
            IList<User> list = new List<User>();

            foreach(User u in Users)
                list.Add(u);

            return list;
        }

        public static User GetUser(string name)
        {
            IEnumerable<User> query = from u in Users
                        where u.UserName == name
                        select u;
            User user = query.First<User>();
            return user;
        }

        public static User GetUser(int id)
        {
            IEnumerable<User> query = from u in Users
                                      where u.Id == id
                                      select u;
            User user = query.First<User>();
            return user;
        }

        public void AddUser(string name)
        {
            User user = new User();
            user.UserName = name;
            user.Id = nextUserId++;
            Users.Add(user);
        }

    }
}