using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using Microsoft.WindowsAzure;
using Microsoft.WindowsAzure.Diagnostics;
using Microsoft.WindowsAzure.ServiceRuntime;

namespace AcmeTicketAgencyWebRole
{
    public class WebRole : RoleEntryPoint
    {
        private readonly string diagnosticConnectionString = "Microsoft.WindowsAzure.Plugins.Diagnostics.ConnectionString";

        public override bool OnStart()
        {
            // For information on handling configuration changes
            // see the MSDN topic at http://go.microsoft.com/fwlink/?LinkId=166357.

            DiagnosticMonitorConfiguration diagnosticMonitorConfiguration = DiagnosticMonitor.GetDefaultInitialConfiguration();
          
            diagnosticMonitorConfiguration.Directories.ScheduledTransferPeriod = TimeSpan.FromMinutes(1d);
            diagnosticMonitorConfiguration.Directories.BufferQuotaInMB = 100;

            diagnosticMonitorConfiguration.Logs.ScheduledTransferPeriod = TimeSpan.FromMinutes(1d);
            diagnosticMonitorConfiguration.Logs.ScheduledTransferLogLevelFilter = LogLevel.Verbose;

            diagnosticMonitorConfiguration.WindowsEventLog.DataSources.Add("Application!*");
            diagnosticMonitorConfiguration.WindowsEventLog.DataSources.Add("System!*");
            diagnosticMonitorConfiguration.WindowsEventLog.ScheduledTransferPeriod = TimeSpan.FromMinutes(1d);

            PerformanceCounterConfiguration performanceCounterConfiguration1 = new PerformanceCounterConfiguration();
            performanceCounterConfiguration1.CounterSpecifier = @"\Processor(_Total)\% Processor Time";
            performanceCounterConfiguration1.SampleRate = TimeSpan.FromSeconds(10d);
            diagnosticMonitorConfiguration.PerformanceCounters.DataSources.Add(performanceCounterConfiguration1);

            PerformanceCounterConfiguration performanceCounterConfiguration2 = new PerformanceCounterConfiguration();
            performanceCounterConfiguration2.CounterSpecifier = @"\Process(" + Process.GetCurrentProcess().ProcessName + @")\Working Set";
            performanceCounterConfiguration2.SampleRate = TimeSpan.FromSeconds(10d);
            diagnosticMonitorConfiguration.PerformanceCounters.DataSources.Add(performanceCounterConfiguration2);
            diagnosticMonitorConfiguration.PerformanceCounters.ScheduledTransferPeriod = TimeSpan.FromMinutes(1d);
            DiagnosticMonitor.Start(diagnosticConnectionString, diagnosticMonitorConfiguration);
        
            Trace.TraceInformation("OnStart completed");


            return base.OnStart();
        }
    }
}
