﻿using System.Collections.Generic;
using System.Web.Mvc;
using AcmeTicketAgencyWebRole.Models;
using AcmeTicketAgencyWebRole.Repositories;

namespace AcmeTicketAgencyWebRole.Controllers
{
    [HandleError]
    public class HomeController : Controller
    {
        public ActionResult Index()
        {
            ViewData["Message"] = "Welcome to the Acme Ticket Agency";

            return View();
        }

        public ActionResult PlaceOrder()
        {
            EventRepository eventRepository = new EventRepository();
            UserRepository userRepository = new UserRepository();

            OrderModel model = new OrderModel();

            model.Events = eventRepository.QueryEvents();

            string[] ids = new string[model.Events.Count];
            for (int i = 0; i < model.Events.Count; i++)
                ids[i] = model.Events[i].EventId.ToString();
            model.EventIds = new SelectList(ids);

            IList<User> users = userRepository.QueryUsers();

            string[] items = new string[users.Count];
            for (int i = 0; i < users.Count; i++)
                items[i] = users[i].UserName;
            model.Users = new SelectList(items);      
 
            return View(model);
        }

        public ActionResult DisplayUserOrders()
        {
            OrdersRepository repository = new OrdersRepository();
      
            UserOrdersModel model = new UserOrdersModel();

            List<UserOrder> userOrders = new List<UserOrder>();
            foreach (Order order in repository.QueryOrders())
            {
                UserOrder userOrder = new UserOrder();
                userOrder.EventId = order.EventId;
                userOrder.EventName = order.Event.EventName;
                userOrder.CustomerName = order.User.UserName;
                userOrder.NumberTickets = order.NumberTickets;

                userOrders.Add(userOrder);
            }

            model.Orders = userOrders;

            return View(model);            
        }

        public RedirectToRouteResult OrderTickets(OrderModel model)
        {
            OrdersRepository repository = new OrdersRepository();
            repository.AddOrder(model.userName, model.eventId, model.numberTickets);
            RedirectToRouteResult rtrr = RedirectToAction("PlaceOrder", "Home");
            return rtrr;
        }

        public ActionResult About()
        {
            return View();
        }
    }
}
