﻿using System;
using System.Collections.Generic;
using System.Data.SqlClient;
using System.Linq;
using AcmeTicketAgencyWebRole.Repositories;

namespace AcmeTicketAgencyWebRole.Models
{
    public class EventRepository
    {
        public IList<Event> QueryEvents()
        {
            IList<Event> list = new List<Event>();

            SqlConnection connection = null;
            SqlDataReader reader = null;

            try
            {
                string query = "select EventId, EventName, TicketInventory, TicketPrice, Artist, Date, Genre, Location from Event";

                string connectionString = ConnectString.GetConnectString();

                connection = new SqlConnection(connectionString);
                connection.Open();
                SqlCommand command = new SqlCommand(query, connection);
                reader = command.ExecuteReader();
                bool result = reader.Read();
                while (result != false)
                {
                    Event e = new Event();
                    e.EventId = Convert.ToInt32(reader[0]);
                    e.EventName = reader[1].ToString();
                    e.TicketInventory = Convert.ToInt32(reader[2]);
                    e.TicketPrice = Convert.ToInt32(reader[3]);
                    e.Artist = reader[4].ToString();
                    e.Date = Convert.ToDateTime(reader[5]);
                    e.Genre = reader[6].ToString();
                    e.Location = reader[7].ToString();
                    list.Add(e);

                    result = reader.Read();
                }
            }
            catch (Exception ex)
            {
                throw ex;
            }
            finally
            {
                if (reader != null)
                    reader.Close();
                if (connection != null)
                    connection.Close();
            }

            return list;
        }

        private Event GetEventByQuery(string query)
        {
            SqlConnection connection = null;
            SqlDataReader reader = null;
            Event evt = null;

            try
            {
                string connectionString = ConnectString.GetConnectString();
                connection = new SqlConnection(connectionString);
                connection.Open();
                SqlCommand command = new SqlCommand(query, connection);
                reader = command.ExecuteReader();
                bool result = reader.Read();
                while (result != false)
                {
                    evt = new Event();
                    evt.EventId = Convert.ToInt32(reader["EventId"]);
                    evt.EventName = reader["EventName"].ToString();
                    evt.Artist = reader["Artist"].ToString();
                    evt.Date = Convert.ToDateTime(reader["Date"]);
                    evt.Genre = reader["Genre"].ToString();
                    evt.Location = reader["Location"].ToString();
                    evt.TicketInventory = Convert.ToInt32(reader["TicketInventory"]);
                    evt.TicketPrice = Convert.ToInt32(reader["TicketPrice"]);

                    result = reader.Read();
                }
            }
            catch (Exception ex)
            {
                throw ex;
            }
            finally
            {
                if (reader != null)
                    reader.Close();
                if (connection != null)
                    connection.Close();
            }

            return evt;
        }

        public Event GetEvent(int eventId)
        {
            string query = "select * from Event where EventId = " + eventId.ToString();
            Event evt = GetEventByQuery(query);

            return evt;
        }

        public Event GetEvent(string eventName)
        {
            string query = "select * from Event where EventName = '" + eventName + "'";
            Event evt = GetEventByQuery(query);

            return evt;
        }
    }

}