﻿using System;
using System.Collections.Generic;
using System.Data.SqlClient;
using System.Linq;
using AcmeTicketAgencyWebRole.Repositories;

namespace AcmeTicketAgencyWebRole.Models
{
    public class OrdersRepository
    {
        public IList<Order> QueryOrders()
        {
            SqlConnection connection = null;
            SqlDataReader reader = null;

            IList<Order> list = new List<Order>();

            try
            {
                string query = "select UserName, Event.EventId, EventName, NumberTickets from Users, Orders, Event where Users.Id = Orders.UserId and Event.EventId = Orders.EventId";

                string connectionString = ConnectString.GetConnectString();

                connection = new SqlConnection(connectionString);
                connection.Open();
                SqlCommand command = new SqlCommand(query, connection);
                reader = command.ExecuteReader();
                bool result = reader.Read();
                while (result != false)
                {
                    Order o = new Order();
                    o.User = new User();
                    o.EventId = Convert.ToInt32(reader["EventId"]);
                    o.User.UserName = reader["UserName"].ToString();
                    o.NumberTickets = Convert.ToInt32(reader["NumberTickets"]);
                    o.Event = new Event();
                    o.Event.EventName = reader["EventName"].ToString();
                    o.Event.EventId = o.EventId;
                    list.Add(o);
                    result = reader.Read();
                }
            }
            catch (Exception ex)
            {
                throw ex;
            }
            finally
            {
                if (reader != null)
                    reader.Close();
                if (connection != null)
                    connection.Close();
            }

            return list;
        }

        public void AddOrder(string userName, int eventId, int numberTickets)
        {
            string connectionString = ConnectString.GetConnectString();

            SqlConnection connection = null;
            SqlDataReader reader = null;

            try
            {
                UserRepository userRepository = new UserRepository();
                User user = userRepository.GetUser(userName);

                EventRepository eventRepository = new EventRepository();
                Event evt = eventRepository.GetEvent(eventId);
                evt.TicketInventory = evt.TicketInventory - numberTickets;

                connection = new SqlConnection(connectionString);
                connection.Open();
                
                string query = "insert into Orders(UserId, EventId, NumberTickets) values(";
                query = query + user.Id.ToString() + ", " + eventId.ToString() + ", " + numberTickets.ToString() + ")";

                SqlCommand command = new SqlCommand(query, connection);
                int numberRows = command.ExecuteNonQuery();

                query = "update Event set TicketInventory = " + evt.TicketInventory.ToString();
                query = query + " where EventId = " + eventId.ToString();
                command = new SqlCommand(query, connection);
                numberRows = command.ExecuteNonQuery();
            }
            catch (Exception ex)
            {
                throw ex;
            }
            finally
            {
                if (reader != null)
                    reader.Close();
                if (connection != null)
                    connection.Close();
            }
        }

    }
}